"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const exec_1 = __importDefault(require("../../lib/cmd/exec"));
const gitStaged = async ({ cwd, log }) => {
    const { stdout } = await exec_1.default({ cmd: 'git', args: ['diff', '--staged', '--name-only'], cwd, log });
    log.info('Return a list of files from the staged');
    if (stdout.trim() === '') {
        log.debug('No files were found in the staged');
        return [];
    }
    const files = stdout.trim().split('\n');
    log.debug(files.map((file) => `▸ ${file}`));
    return files;
};
exports.default = gitStaged;
