"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const access_1 = __importDefault(require("../../lib/cmd/access"));
const exec_1 = __importDefault(require("../../lib/cmd/exec"));
const packageUpdate_1 = __importDefault(require("./packageUpdate"));
const npmInit = async (argv, { settings }) => {
    const path = path_1.join(argv.cwd, 'package.json');
    const isExists = await access_1.default(path);
    if (!isExists) {
        argv.log.info('Initialize the package.json');
        await exec_1.default({ ...argv, cmd: 'npm', args: ['init', '-y'] });
        await packageUpdate_1.default(argv, { settings });
    }
    else {
        argv.log.info('package.json already exists');
    }
};
exports.default = npmInit;
