"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tool_lib_1 = require("@kettil/tool-lib");
const exec_1 = __importDefault(require("../../lib/cmd/exec"));
const npmInstall = async ({ cwd, log }, { packages, mode }) => {
    if (packages.length > 0) {
        const uniquePackages = tool_lib_1.uniqueArray(packages.sort(tool_lib_1.compareAsc));
        const parameters = ['install', ...uniquePackages, `--save-${mode}`];
        const logPackages = uniquePackages.map((name) => `▸ ${name}`).join('\n');
        log.info(`Install following ${mode} packages:\n${logPackages}`);
        await exec_1.default({ cmd: 'npm', args: parameters, cwd, log });
    }
};
exports.default = npmInstall;
