"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPackagePath = void 0;
const path_1 = require("path");
const access_1 = __importDefault(require("../../lib/cmd/access"));
const readFile_1 = __importDefault(require("../../lib/cmd/readFile"));
const getPackagePath = (cwd) => path_1.join(cwd, 'package.json');
exports.getPackagePath = getPackagePath;
const npmPackageLoad = async ({ cwd, log }, { key, throwError }) => {
    const path = exports.getPackagePath(cwd);
    const isExists = await access_1.default(path);
    if (!isExists) {
        throw new Error('package.json is not found');
    }
    log.debug('Read the package.json');
    const config = await readFile_1.default(path, true);
    if (typeof key === 'undefined') {
        return config;
    }
    const value = config[key];
    if (throwError && typeof value === 'undefined') {
        throw new TypeError(`The package.json value "${key}" is undefiend`);
    }
    return value;
};
exports.default = npmPackageLoad;
