"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tool_lib_1 = require("@kettil/tool-lib");
const writeFile_1 = __importDefault(require("../../lib/cmd/writeFile"));
const packageLoad_1 = __importStar(require("./packageLoad"));
const update = (config, values) => {
    if (tool_lib_1.objectKeys(values).length === 0) {
        return config;
    }
    return Object.assign(tool_lib_1.isObject(config) ? config : {}, values);
};
const updatePeerDependencies = (config, values) => {
    const peerDependencies = {};
    const packages = config.devDependencies;
    if (!tool_lib_1.isObject(packages)) {
        throw new Error('In the package.json is the devDependencies empty');
    }
    values.forEach((value) => {
        const version = packages[value];
        if (typeof version !== 'string') {
            throw new TypeError(`The peerDependency "${value}" is not found in the devDependencies`);
        }
        peerDependencies[value] = version;
    });
    return update(config.peerDependencies, peerDependencies);
};
const npmPackageUpdate = async (argv, { settings: { bin, scripts, peerDependencies, ...settings } }) => {
    const { cwd, log } = argv;
    const config = await packageLoad_1.default(argv, {});
    if (!tool_lib_1.isObject(config)) {
        throw new TypeError('Package could not be interpreted as an object');
    }
    Object.assign(config, settings);
    // Update the bin part
    if (bin) {
        config.bin = update(config.bin, bin);
    }
    // Update the scripts part
    if (scripts) {
        config.scripts = update(config.scripts, scripts);
    }
    // Update the peerDependencies part
    if (peerDependencies && peerDependencies.length > 0) {
        config.peerDependencies = updatePeerDependencies(config, peerDependencies);
    }
    log.info('Extend the package.json');
    await writeFile_1.default(packageLoad_1.getPackagePath(cwd), config);
};
exports.default = npmPackageUpdate;
