"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const depcheck_1 = __importStar(require("depcheck"));
const dependencyError_1 = __importDefault(require("../../lib/errors/dependencyError"));
const options = {
    ignoreDirs: ['node_modules'],
    parsers: {
        '*.js': depcheck_1.parser.es6,
        '*.jsx': depcheck_1.parser.jsx,
        '*.ts': depcheck_1.parser.typescript,
        '*.tsx': depcheck_1.parser.typescript,
    },
    detectors: [depcheck_1.detector.requireCallExpression, depcheck_1.detector.importDeclaration],
    specials: [depcheck_1.special.babel, depcheck_1.special.eslint, depcheck_1.special.prettier, depcheck_1.special.jest, depcheck_1.special.husky, depcheck_1.special.webpack],
};
const depcheck = async ({ cwd }) => {
    const { dependencies, devDependencies, invalidDirs, invalidFiles } = await depcheck_1.default(cwd, options);
    const msg = [];
    if (Object.keys(invalidDirs).length > 0) {
        msg.push(chalk_1.red('No access to the folders:'));
        Object.keys(invalidDirs)
            .sort()
            .forEach((file) => {
            msg.push(`- ${file}`);
        });
        msg.push('');
    }
    if (Object.keys(invalidFiles).length > 0) {
        msg.push(chalk_1.red('No access or syntax error in the files:'));
        Object.keys(invalidFiles)
            .sort()
            .forEach((file) => {
            msg.push(`- ${file}`);
        });
        msg.push('');
    }
    if (dependencies.length > 0 || devDependencies.length > 0) {
        msg.push(chalk_1.red('The dependencies are not used:'));
        dependencies
            .concat(devDependencies)
            .sort()
            .forEach((file) => {
            msg.push(`- ${file}`);
        });
    }
    if (msg.length > 0) {
        throw new dependencyError_1.default('Depcheck error', msg);
    }
};
exports.default = depcheck;
