"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.actions = exports.lint = exports.init = exports.gitMsg = exports.gitCommit = void 0;
const add_1 = __importDefault(require("./actions/git/add"));
const commit_1 = __importDefault(require("./actions/git/commit"));
const init_1 = __importDefault(require("./actions/git/init"));
const staged_1 = __importDefault(require("./actions/git/staged"));
const file_1 = __importDefault(require("./actions/node/file"));
const folder_1 = __importDefault(require("./actions/node/folder"));
const template_1 = __importDefault(require("./actions/node/template"));
const init_2 = __importDefault(require("./actions/npm/init"));
const install_1 = __importDefault(require("./actions/npm/install"));
const commitlint_1 = __importDefault(require("./actions/tools/commitlint"));
const eslint_1 = __importDefault(require("./actions/tools/eslint"));
const prettier_1 = __importDefault(require("./actions/tools/prettier"));
var gitCommit_1 = require("./sequences/gitCommit");
Object.defineProperty(exports, "gitCommit", { enumerable: true, get: function () { return gitCommit_1.handler; } });
var gitMessage_1 = require("./sequences/gitMessage");
Object.defineProperty(exports, "gitMsg", { enumerable: true, get: function () { return gitMessage_1.handler; } });
var init_3 = require("./sequences/init");
Object.defineProperty(exports, "init", { enumerable: true, get: function () { return init_3.handler; } });
var lint_1 = require("./sequences/lint");
Object.defineProperty(exports, "lint", { enumerable: true, get: function () { return lint_1.handler; } });
exports.actions = {
    gitAdd: add_1.default,
    gitCommit: commit_1.default,
    gitInit: init_1.default,
    gitStaged: staged_1.default,
    nodeFile: file_1.default,
    nodeFolder: folder_1.default,
    nodeTemplate: template_1.default,
    npmInit: init_2.default,
    npmInstall: install_1.default,
    commitlint: commitlint_1.default,
    eslint: eslint_1.default,
    prettier: prettier_1.default,
};
