"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.spinnerBreak = exports.spinnerAction = void 0;
const tool_lib_1 = require("@kettil/tool-lib");
const ora_1 = __importDefault(require("ora"));
const instance = ora_1.default({
    color: 'white',
    spinner: 'dots',
});
const isSpinning = () => instance.isSpinning;
const start = (text) => {
    instance.start(text);
};
const stop = (key, text) => {
    if (isSpinning()) {
        instance[key](text);
    }
};
const succeed = (p) => {
    stop('succeed');
    return p;
};
const fail = (error) => {
    stop('fail');
    throw error;
};
const spinnerAction = (action, text) => {
    start(text);
    return action.then(succeed, fail);
};
exports.spinnerAction = spinnerAction;
const spinnerBreak = () => {
    if (isSpinning()) {
        stop('stop');
        return () => instance.start();
    }
    return tool_lib_1.dummy;
};
exports.spinnerBreak = spinnerBreak;
