"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorHandler = exports.builderDefault = void 0;
const dependencyError_1 = __importDefault(require("../errors/dependencyError"));
const executableError_1 = __importDefault(require("../errors/executableError"));
const builderDefault = (cmd, callback) => (yargs) => callback(yargs).usage(`Usage: $0 ${cmd} [options]`).help().version(false)
    .showHelpOnFail(false);
exports.builderDefault = builderDefault;
const errorHandler = (argv, error) => {
    if (error instanceof executableError_1.default) {
        argv.log.log(error.stdout);
        argv.log.log(error.stderr);
        /* eslint-disable-next-line node/no-process-exit, unicorn/no-process-exit */
        process.exit(1);
    }
    if (error instanceof dependencyError_1.default) {
        argv.log.log(error.list);
        /* eslint-disable-next-line node/no-process-exit, unicorn/no-process-exit */
        process.exit(1);
    }
    throw error;
};
exports.errorHandler = errorHandler;
