"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.builder = exports.desc = exports.command = void 0;
const depcheck_1 = __importDefault(require("../actions/tools/depcheck"));
const spinner_1 = require("../lib/cli/spinner");
const yargs_1 = require("../lib/cli/yargs");
const logo_1 = __importDefault(require("../lib/logo"));
exports.command = 'debs';
exports.desc = 'Run the dependency check';
const options = { group: `${exports.command}-Options` };
exports.builder = yargs_1.builderDefault(exports.command, (yargs) => yargs.options({
    ci: { ...options, type: 'boolean', default: false, describe: 'Run it in CI mode' },
}));
const handler = async (argv) => {
    try {
        if (argv.ci) {
            await depcheck_1.default(argv);
        }
        else {
            await logo_1.default();
            await spinner_1.spinnerAction(depcheck_1.default(argv), 'DepCheck');
        }
    }
    catch (error) {
        yargs_1.errorHandler(argv, error);
    }
};
exports.handler = handler;
