"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.builder = exports.desc = exports.command = void 0;
const packageLoad_1 = __importDefault(require("../actions/npm/packageLoad"));
const eslint_1 = __importDefault(require("../actions/tools/eslint"));
const prettier_1 = __importStar(require("../actions/tools/prettier"));
const tsc_1 = __importDefault(require("../actions/tools/tsc"));
const spinner_1 = require("../lib/cli/spinner");
const yargs_1 = require("../lib/cli/yargs");
const logo_1 = __importDefault(require("../lib/logo"));
exports.command = 'lint';
exports.desc = 'Run the code quality tools';
const services = ['eslint', 'prettier', 'typescript'];
const options = { group: `${exports.command}-Options` };
exports.builder = yargs_1.builderDefault(exports.command, (yargs) => yargs.options({
    ci: { ...options, type: 'boolean', default: false, describe: 'Run it in CI mode' },
    only: { ...options, choices: services, implies: 'ci', describe: 'Run a single code quality tool' },
}));
const handler = async (argv) => {
    try {
        const isPrivate = await packageLoad_1.default(argv, { key: 'private' });
        if (argv.ci) {
            if (typeof argv.only === 'undefined' || argv.only === 'prettier') {
                await prettier_1.default(argv, { write: false, extension: prettier_1.extensionCi });
            }
            if (typeof argv.only === 'undefined' || argv.only === 'eslint') {
                await eslint_1.default(argv, { write: false });
            }
            if ((typeof argv.only === 'undefined' && isPrivate === true) || argv.only === 'typescript') {
                await spinner_1.spinnerAction(tsc_1.default(argv, { mode: 'type-check' }), 'Typescript');
            }
        }
        else {
            await logo_1.default();
            await spinner_1.spinnerAction(prettier_1.default(argv, { write: true }), 'Prettier');
            await spinner_1.spinnerAction(eslint_1.default(argv, { write: true }), 'Eslint');
            if (isPrivate === true) {
                await spinner_1.spinnerAction(tsc_1.default(argv, { mode: 'type-check' }), 'Typescript');
            }
        }
    }
    catch (error) {
        yargs_1.errorHandler(argv, error);
    }
};
exports.handler = handler;
